diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/qos-frame-exchange-manager.h ns-3.34/src/wifi/model/qos-frame-exchange-manager.h
--- ns-3.33/src/wifi/model/qos-frame-exchange-manager.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/qos-frame-exchange-manager.h	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,177 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Universita' degli Studi di Napoli Federico II
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#ifndef QOS_FRAME_EXCHANGE_MANAGER_H
+#define QOS_FRAME_EXCHANGE_MANAGER_H
+
+#include "frame-exchange-manager.h"
+
+namespace ns3 {
+
+
+/**
+ * \ingroup wifi
+ *
+ * QosFrameExchangeManager handles the frame exchange sequences
+ * for QoS stations.
+ * Note that Basic Block Ack is not supported.
+ */
+class QosFrameExchangeManager : public FrameExchangeManager
+{
+public:
+  /**
+   * \brief Get the type ID.
+   * \return the object TypeId
+   */
+  static TypeId GetTypeId (void);
+  QosFrameExchangeManager ();
+  virtual ~QosFrameExchangeManager ();
+
+  bool StartTransmission (Ptr<Txop> edca) override;
+
+  /**
+   * Recompute the protection and acknowledgment methods to use if the given MPDU
+   * is added to the frame being built (as described by the given TX parameters)
+   * and check whether the duration of the frame exchange sequence (including
+   * protection and acknowledgment) does not exceed the given available time.
+   * The protection and acknowledgment methods held by the given TX parameters are
+   * only updated if the given MPDU can be added.
+   *
+   * \param mpdu the MPDU to add to the frame being built
+   * \param txParams the TX parameters describing the frame being built
+   * \param availableTime the time limit on the frame exchange sequence
+   * \return true if the given MPDU can be added to the frame being built
+   */
+  bool TryAddMpdu (Ptr<const WifiMacQueueItem> mpdu, WifiTxParameters& txParams, Time availableTime) const;
+
+  /**
+   * Check whether the given MPDU can be added to the frame being built (as described
+   * by the given TX parameters) without violating the given constraint on the
+   * PPDU transmission duration.
+   *
+   * \param mpdu the MPDU to add to the frame being built
+   * \param txParams the TX parameters describing the frame being built
+   * \param ppduDurationLimit the time limit on the PPDU transmission duration
+   * \return true if the given MPDU can be added to the frame being built
+   */
+  virtual bool IsWithinLimitsIfAddMpdu (Ptr<const WifiMacQueueItem> mpdu, const WifiTxParameters& txParams,
+                                        Time ppduDurationLimit) const;
+
+  /**
+   * Check whether the transmission time of the frame being built (as described
+   * by the given TX parameters) does not exceed the given PPDU duration limit
+   * if the size of the PSDU addressed to the given receiver becomes
+   * <i>ppduPayloadSize</i>. Also check that the PSDU size does not exceed the
+   * max PSDU size for the modulation class being used.
+   *
+   * \param ppduPayloadSize the new PSDU size
+   * \param receiver the MAC address of the receiver of the PSDU
+   * \param txParams the TX parameters describing the frame being built
+   * \param ppduDurationLimit the limit on the PPDU duration
+   * \return true if the constraints on the PPDU duration limit and the maximum PSDU size are met
+   */
+  virtual bool IsWithinSizeAndTimeLimits (uint32_t ppduPayloadSize, Mac48Address receiver,
+                                          const WifiTxParameters& txParams, Time ppduDurationLimit) const;
+
+protected:
+  void DoDispose () override;
+
+  void ReceiveMpdu (Ptr<WifiMacQueueItem> mpdu, RxSignalInfo rxSignalInfo,
+                    const WifiTxVector& txVector, bool inAmpdu) override;
+  void PreProcessFrame (Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector) override;
+  Time GetFrameDurationId (const WifiMacHeader& header, uint32_t size,
+                           const WifiTxParameters& txParams,
+                           Ptr<Packet> fragmentedPacket) const override;
+  Time GetRtsDurationId (const WifiTxVector& rtsTxVector, Time txDuration,
+                         Time response) const override;
+  Time GetCtsToSelfDurationId (const WifiTxVector& ctsTxVector, Time txDuration,
+                               Time response) const override;
+  void TransmissionSucceeded (void) override;
+  void TransmissionFailed (void) override;
+
+  /**
+   * Request the FrameExchangeManager to start a frame exchange sequence.
+   *
+   * \param edca the EDCA that gained channel access
+   * \param txopDuration the duration of a TXOP. This value is only used when a
+   *                     new TXOP is started (and hence the TXOP limit for the
+   *                     given EDCAF is non-zero)
+   * \return true if a frame exchange sequence was started, false otherwise
+   */
+  virtual bool StartTransmission (Ptr<QosTxop> edca, Time txopDuration);
+
+  /**
+   * Start a frame exchange (including protection frames and acknowledgment frames
+   * as needed) that fits within the given <i>availableTime</i> (if different than
+   * Time::Min()).
+   *
+   * \param edca the EDCAF which has been granted the opportunity to transmit
+   * \param availableTime the amount of time allowed for the frame exchange. Pass
+   *                      Time::Min() in case the TXOP limit is null
+   * \param initialFrame true if the frame being transmitted is the initial frame
+   *                     of the TXOP. This is used to determine whether the TXOP
+   *                     limit can be exceeded
+   * \return true if a frame exchange is started, false otherwise
+   */
+  virtual bool StartFrameExchange (Ptr<QosTxop> edca, Time availableTime, bool initialFrame);
+
+  /**
+   * Perform a PIFS recovery as a response to transmission failure within a TXOP.
+   * If the carrier sense indicates that the medium is idle, continue the TXOP.
+   * Otherwise, release the channel.
+   */
+  void PifsRecovery (void);
+
+  /**
+   * Send a CF-End frame to indicate the completion of the TXOP, provided that
+   * the remaining duration is long enough to transmit this frame.
+   *
+   * \return true if a CF-End frame was sent, false otherwise
+   */
+  virtual bool SendCfEndIfNeeded (void);
+
+  /**
+   * Set the TXOP holder, if needed, based on the received frame
+   *
+   * \param psdu the received PSDU
+   * \param txVector TX vector of the received PSDU
+   */
+  virtual void SetTxopHolder (Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector);
+
+  Ptr<QosTxop> m_edca;                       //!< the EDCAF that gained channel access
+  Mac48Address m_txopHolder;                 //!< MAC address of the TXOP holder
+
+private:
+
+  /**
+   * Cancel the PIFS recovery event and have the EDCAF attempting PIFS recovery
+   * release the channel.
+   */
+  void CancelPifsRecovery (void);
+
+  bool m_initialFrame;                       //!< true if transmitting the initial frame of a TXOP
+  bool m_pifsRecovery;                       //!< true if performing a PIFS recovery after failure
+  EventId m_pifsRecoveryEvent;               //!< event associated with an attempt of PIFS recovery
+  Ptr<Txop> m_edcaBackingOff;                //!< channel access function that invoked backoff during TXOP
+};
+
+} //namespace ns3
+
+#endif /* QOS_FRAME_EXCHANGE_MANAGER_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/qos-txop.cc ns-3.34/src/wifi/model/qos-txop.cc
--- ns-3.33/src/wifi/model/qos-txop.cc	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/qos-txop.cc	2021-07-14 10:31:07.000000000 -0700
@@ -31,18 +31,18 @@
 #include "mgt-headers.h"
 #include "wifi-mac-trailer.h"
 #include "wifi-mac-queue.h"
-#include "mac-low.h"
 #include "qos-blocked-destinations.h"
 #include "wifi-remote-station-manager.h"
 #include "msdu-aggregator.h"
 #include "mpdu-aggregator.h"
 #include "ctrl-headers.h"
 #include "wifi-phy.h"
-#include "wifi-ack-policy-selector.h"
 #include "wifi-psdu.h"
+#include "ns3/ht-frame-exchange-manager.h"
+#include "wifi-tx-parameters.h"
 
 #undef NS_LOG_APPEND_CONTEXT
-#define NS_LOG_APPEND_CONTEXT if (m_low != 0) { std::clog << "[mac=" << m_low->GetAddress () << "] "; }
+#define NS_LOG_APPEND_CONTEXT if (m_stationManager != 0 && m_stationManager->GetMac () != 0) { std::clog << "[mac=" << m_stationManager->GetMac ()->GetAddress () << "] "; }
 
 namespace ns3 {
 
@@ -92,21 +92,15 @@
 }
 
 QosTxop::QosTxop ()
-  : m_typeOfStation (STA),
-    m_blockAckType (COMPRESSED_BLOCK_ACK),
-    m_startTxop (Seconds (0)),
-    m_isAccessRequestedForRts (false),
-    m_currentIsFragmented (false)
+  : m_startTxop (Seconds (0)),
+    m_txopDuration (Seconds (0))
 {
   NS_LOG_FUNCTION (this);
   m_qosBlockedDestinations = Create<QosBlockedDestinations> ();
   m_baManager = CreateObject<BlockAckManager> ();
   m_baManager->SetQueue (m_queue);
-  m_baManager->SetBlockAckType (m_blockAckType);
   m_baManager->SetBlockDestinationCallback (MakeCallback (&QosBlockedDestinations::Block, m_qosBlockedDestinations));
   m_baManager->SetUnblockDestinationCallback (MakeCallback (&QosBlockedDestinations::Unblock, m_qosBlockedDestinations));
-  m_baManager->SetTxOkCallback (MakeCallback (&QosTxop::BaTxOk, this));
-  m_baManager->SetTxFailedCallback (MakeCallback (&QosTxop::BaTxFailed, this));
 }
 
 QosTxop::~QosTxop ()
@@ -118,12 +112,51 @@
 QosTxop::DoDispose (void)
 {
   NS_LOG_FUNCTION (this);
-  m_ackPolicySelector = 0;
   m_baManager = 0;
   m_qosBlockedDestinations = 0;
+  m_qosFem = 0;
   Txop::DoDispose ();
 }
 
+void
+QosTxop::SetQosQueueSize (Ptr<WifiMacQueueItem> mpdu)
+{
+  NS_LOG_FUNCTION (this << *mpdu);
+
+  WifiMacHeader& hdr = mpdu->GetHeader ();
+  NS_ASSERT (hdr.IsQosData ());
+
+  uint32_t bufferSize = m_queue->GetNBytes (hdr.GetQosTid (), hdr.GetAddr1 ())
+                        + m_baManager->GetRetransmitQueue ()->GetNBytes (hdr.GetQosTid (), hdr.GetAddr1 ());
+  // A queue size value of 254 is used for all sizes greater than 64 768 octets.
+  uint8_t queueSize = static_cast<uint8_t> (std::ceil (std::min (bufferSize, 64769u) / 256.0));
+  NS_LOG_DEBUG ("Buffer size=" << bufferSize << " Queue Size=" << +queueSize);
+  hdr.SetQosQueueSize (queueSize);
+}
+
+void
+QosTxop::SetQosFrameExchangeManager (const Ptr<QosFrameExchangeManager> qosFem)
+{
+  NS_LOG_FUNCTION (this << qosFem);
+  m_qosFem = qosFem;
+}
+
+void
+QosTxop::SetDroppedMpduCallback (DroppedMpdu callback)
+{
+  NS_LOG_FUNCTION (this << &callback);
+  Txop::SetDroppedMpduCallback (callback);
+  m_baManager->GetRetransmitQueue ()->TraceConnectWithoutContext ("Expired",
+                                                                  m_droppedMpduCallback
+                                                                  .Bind (WIFI_MAC_DROP_EXPIRED_LIFETIME));
+}
+
+Ptr<BlockAckManager>
+QosTxop::GetBaManager (void)
+{
+  return m_baManager;
+}
+
 bool
 QosTxop::GetBaAgreementEstablished (Mac48Address address, uint8_t tid) const
 {
@@ -146,15 +179,16 @@
 QosTxop::PrepareBlockAckRequest (Mac48Address recipient, uint8_t tid) const
 {
   NS_LOG_FUNCTION (this << recipient << +tid);
+  NS_ASSERT (QosUtilsMapTidToAc (tid) == m_ac);
 
-  CtrlBAckRequestHeader reqHdr = m_low->GetEdca (tid)->m_baManager->GetBlockAckReqHeader (recipient, tid);
+  CtrlBAckRequestHeader reqHdr = m_baManager->GetBlockAckReqHeader (recipient, tid);
   Ptr<Packet> bar = Create<Packet> ();
   bar->AddHeader (reqHdr);
 
   WifiMacHeader hdr;
   hdr.SetType (WIFI_MAC_CTL_BACKREQ);
   hdr.SetAddr1 (recipient);
-  hdr.SetAddr2 (m_low->GetAddress ());
+  hdr.SetAddr2 (m_stationManager->GetMac ()->GetAddress ());
   hdr.SetDsNotTo ();
   hdr.SetDsNotFrom ();
   hdr.SetNoRetry ();
@@ -177,37 +211,27 @@
   m_baManager->SetWifiRemoteStationManager (m_stationManager);
 }
 
-void
-QosTxop::SetAckPolicySelector (Ptr<WifiAckPolicySelector> ackSelector)
-{
-  NS_LOG_FUNCTION (this << ackSelector);
-  m_ackPolicySelector = ackSelector;
-}
-
-Ptr<WifiAckPolicySelector>
-QosTxop::GetAckPolicySelector (void) const
-{
-  return m_ackPolicySelector;
-}
-
-void
-QosTxop::SetTypeOfStation (TypeOfStation type)
-{
-  NS_LOG_FUNCTION (this << +type);
-  m_typeOfStation = type;
-}
-
-TypeOfStation
-QosTxop::GetTypeOfStation (void) const
+bool
+QosTxop::UseExplicitBarAfterMissedBlockAck (void) const
 {
-  return m_typeOfStation;
+  return m_useExplicitBarAfterMissedBlockAck;
 }
 
 bool
 QosTxop::HasFramesToTransmit (void)
 {
-  bool ret = (m_currentPacket != 0 || m_baManager->HasPackets () || !m_queue->IsEmpty ());
-  NS_LOG_FUNCTION (this << ret);
+  // check if the BA manager retransmit queue is empty, so that expired
+  // frames (if any) are removed and a BlockAckRequest is scheduled to advance
+  // the starting sequence number of the transmit (and receiver) window
+  bool baManagerHasPackets = m_baManager->HasPackets ();
+  // remove MSDUs with expired lifetime starting from the head of the queue
+  // TODO Add a WifiMacQueue method that serves this purpose; IsEmpty () can
+  // then reuse such method.
+  m_queue->IsEmpty ();
+  bool queueIsNotEmpty = (m_queue->PeekFirstAvailable (m_qosBlockedDestinations) != m_queue->end ());
+
+  bool ret = (baManagerHasPackets || queueIsNotEmpty);
+  NS_LOG_FUNCTION (this << baManagerHasPackets << queueIsNotEmpty);
   return ret;
 }
 
